local OO = MiTu.using(MiTu.OO)
MiTu.CastMonitor = MiTu.CastMonitor or {}
local CurrentPackage = MiTu.BeginPackage(MiTu.CastMonitor)

--------------------------------------------------------------------------------
--############################################################################--
--------------------------------------------------------------------------------
OO.NewClass(CurrentPackage, "CastMonitor", 
    function(self)
    
    	self.frame = nil
    
    	self:initGUI()
    end
)
--------------------------------------------------------------------------------
-- static
--------------------------------------------------------------------------------
CastMonitor.getReactionColor = function(unit, otherUnit)
	local isFriend = UnitIsFriend(unit, otherUnit)
	local isEnemy = UnitIsEnemy(unit, otherUnit)
	if (isFriend == 1) then
		return CastMonitorSettings.TargetColors.Friendly
	elseif (isEnemy == 1) then
		return CastMonitorSettings.TargetColors.Hostile
	else
		return CastMonitorSettings.TargetColors.None
	end
end
--------------------------------------------------------------------------------
--
--------------------------------------------------------------------------------
function CastMonitor:showFrame()
	self.frame:show()
end
function CastMonitor:hideFrame()
	self.frame:hide()
end
function CastMonitor:toggleFrame()
	self.frame:toggle()
end

--------------------------------------------------------------------------------
--
--------------------------------------------------------------------------------
function CastMonitor:initGUI()
	self.frame = CastMonitorFrame(self)
	self.frame:addItem("player")
end

--------------------------------------------------------------------------------
-- Adds the players current Target to the list of watched raid members
--------------------------------------------------------------------------------
function CastMonitor:addCurrentTarget()

	local unitName, realm = UnitName("target")
	
	-- Nothing to do here if there is no target
	if not unitName then
		return
	end
	
	if (realm and (realm ~= "")) then
		unitName = unitName.."-"..realm
	end
	
	
	local unitID = self:getRaidUnitID(unitName)
	
	if (not unitID) then
		-- TODO: Fehlermeldung ausgeben. Ziel scheint nicht im Raid zu sein
		DEFAULT_CHAT_FRAME:AddMessage("CastMonitor: Cannot add unit '"
			..unitName.."': unit not in raid")
		return
	end
	
	self.frame:addItem(unitID)
	
end
--------------------------------------------------------------------------------
-- Gets the raid unitid for the given character name or nil of there is no 
-- such character
--------------------------------------------------------------------------------
function CastMonitor:getRaidUnitID(unitName)
	
	for raidIndex = 1, GetNumRaidMembers() do
		local name, rank, subgroup, level, class, fileName, 
  			zone, online, isDead, role, isML = GetRaidRosterInfo(raidIndex);
  		if (name == unitName) then
  			return "raid"..raidIndex
  		end
	end
	-- not found in current raid
	return nil
end